{
**********************************************************
*                                                        *
*        xCoder 0.1 copyright (c) 1999-2001 by           *
*                                                        *
*                 _TeStON_ (17 lat)                      *
*                                                        *
*             http://www.teston.hg.pl/                   *
*                                                        *
*                 testonek@wp.pl                         *
*                                                        *
* Uzytki:                                                *
*                                                        *
*  - GMOUSE (GMOUSE.TPU) - by gr0g (Hi gr0g)             *
*                                                        *
**********************************************************
}
uses Crt, Dos, GMouse;
type TByteFile = file of Byte;
     TProgressBar = object
        Max: LongInt;
        Position: LongInt;
        Width: Integer;
        Height: Integer;
        X: Integer;
        Y: Integer;
        Color: Integer;
        BkColor: Integer;
        Ch: Char;
        BkCh: Char;
        Zap: Integer;
        ZapS: Integer;
        ShowText: Boolean;
        PerColor: Integer;
        TX: Integer;
        TY: Integer;
        procedure Draw;
     end;
     TLabel = object
        Caption: String;
        Width: Integer;
        X: Integer;
        Y: Integer;
        Color: Integer;
        procedure Draw;
     end;
     TEdit = object
        Text: String;
        X: Integer;
        Y: Integer;
        Width: Integer;
        Color: Integer;
        FontColor: Integer;
        Focused: Boolean;
        procedure Draw;
     end;
     TCheckBox = object
        Caption: String;
        X: Integer;
        Y: Integer;
        Color: Integer;
        FontColor: Integer;
        Checked: Boolean;
        CharCheck: Char;
        procedure Draw;
     end;
     TBevel = object
        X: Integer;
        Y: Integer;
        Width: Integer;
        Height: Integer;
        Color: Integer;
        Caption: String;
        procedure Draw;
     end;
     TButton = object
        X: Integer;
        Y: Integer;
        Width: Integer;
        Height: Integer;
        Color: Integer;
        Caption: String;
        procedure Draw;
     end;
     TCloseButton = object
        X: Integer;
        Y: Integer;
        Width: Integer;
        Height: Integer;
        Color: Integer;
        Caption: String;
        procedure Draw;
     end;
     TWindow = object
        X: Integer;
        Y: Integer;
        Width: Integer;
        Height: Integer;
        Color: Integer;
        Caption: String;
        procedure Draw;
     end;
     THelpBox = object
        X: Integer;
        Y: Integer;
        Width: Integer;
        Height: Integer;
        Color: Integer;
        BkColor: Integer;
        procedure Draw;
     end;
     TAboutBox = object
        X: Integer;
        Y: Integer;
        Width: Integer;
        Height: Integer;
        Color: Integer;
        BkColor: Integer;
        procedure Draw;
     end;
     TMaskEdit = object
        Text: String;
        X: Integer;
        Y: Integer;
        MaskChar: Char;
        Masked: Boolean;
        Width: Integer;
        Color: Integer;
        FontColor: Integer;
        Focused: Boolean;
        procedure Draw;
     end;

var
 BF, BFD: TByteFile;
 Wart, Prze, X, Y, w1, w2, w3: Byte;
 ProgressBar1: TProgressBar;
 Label1, Label2, Label3, Label4, Label5, Label6, InF, OuF, Label7: TLabel;
 Input, Output: TEdit;
 Password: TMaskEdit;
 Button1: TButton;
 CloseBtn, HelpBtn, AboutBtn: TCloseButton;
 Bevel1, OptionsBev, BtnBev, ProgBev, InfoBev, FilesBev, PasBev: TBevel;
 CheckBox1, Mask: TCheckBox;
 Window: TWindow;
 HelpBox: THelpBox;
 AboutBox: TAboutBox;
 ATTRS: String;
 Attr: Word;
 Size, Time, Klucz: LongInt;
 Szyf: Boolean;
 DT: DateTime;
 Zk, Zk2: Char;

const
 Mode = 345;
 MT_CODING   = 'Kodowanie...         ';
 MT_DECODING = 'Dekodowanie...       ';
 MT_DONE     = 'Zakonczono pomyslnie ';
 MT_ABORT    = 'Anulowano            ';
 BkCol = 7;

function PZero(w : Word) : String;
var
  s : String;
begin
  Str(w:0,s);
  if Length(s) = 1 then
    s := '0' + s;
  PZero := s;
end;

function MakeKey(S: String): LongInt;
 var
  I,Result: LongInt;
begin
 Result := 0;
 for I := 1 to Length(S) do
  begin
   Result := Result + (Word(Ord(S[I])) xor 42);
  end;
 Result := Round(Sqrt(Result));
 Result := Sqr(Result);
 if Result < 0 then
  Result := Result * -1;
 Makekey := Result;
end;

procedure TabHit;
begin
 if Password.Focused = True then
  begin
   Password.Focused := False;
   Input.Focused := True;
  end else
 if Input.Focused = True then
  begin
   Input.Focused := False;
   Output.Focused := True;
  end else
 if Output.Focused = True then
  begin
   Output.Focused := False;
   Password.Focused := True;
  end else
  Password.Focused := True;
 Password.Draw;
 Input.Draw;
 Output.Draw;
end;

procedure DrawAll;
begin
 TextBackGround(BkCol);
 Label1.Draw;
 TextBackGround(BkCol);
 Label2.Draw;
 TextBackGround(BkCol);
 Label3.Draw;
 TextBackGround(BkCol);
 Label4.Draw;
 TextBackGround(BkCol);
 Label5.Draw;
 TextBackGround(BkCol);
 Label6.Draw;
 TextBackGround(BkCol);
 InF.Draw;
 TextBackGround(BkCol);
 OuF.Draw;
 TextBackGround(BkCol);
 Label7.Draw;
 TextBackGround(BkCol);
 Input.Draw;
 TextBackGround(BkCol);
 Output.Draw;
 TextBackGround(BkCol);
 Password.Draw;
 TextBackGround(BkCol);
 Button1.Draw;
 TextBackGround(BkCol);
 CloseBtn.Draw;
 TextBackGround(BkCol);
 Bevel1.Draw;
 TextBackGround(BkCol);
 OptionsBev.Draw;
 TextBackGround(BkCol);
 BtnBev.Draw;
 TextBackGround(BkCol);
 AboutBtn.Draw;
 TextBackGround(BkCol);
 HelpBtn.Draw;
 TextBackGround(BkCol);
 ProgBev.Draw;
 TextBackGround(BkCol);
 InfoBev.Draw;
 TextBackGround(BkCol);
 FilesBev.Draw;
 TextBackGround(BkCol);
 PasBev.Draw;
 TextBackGround(BkCol);
 CheckBox1.Draw;
 TextBackGround(BkCol);
 Mask.Draw;
 TextBackGround(BkCol);
 Window.Draw;
 TextBackGround(BkCol);
 ProgressBar1.Position := 12;
 ProgressBar1.Draw;
 ProgressBar1.Position := 0;
 ProgressBar1.Draw;
 TextBackGround(BkCol);
end;

procedure Init;
begin
 TextMode(Mode);
 TextBackground(BkCol);
 ClrScr;
 TMouseTrap(0,0,78,49);
 with Window do
  begin
   X := 1;
   Y := 1;
   Width := 78;
   Height := 49;
   Color := 15;
   Caption := 'xCoder 0.1 - copyright (c) 1999-2001 by _TeStON_ - www.teston.hg.pl';
   Draw;
  end;
 with CheckBox1 do
  begin
   X := 6;
   Y := 9;
   Checked := True;
   CharCheck := 'x';
   Color := 2;
   FontColor := 0;
   Caption := 'Koduj / Dekoduj';
   Draw;
  end;
 with Mask do
  begin
   X := 60;
   Y := 19;
   Checked := True;
   CharCheck := 'x';
   Color := 2;
   FontColor := 0;
   Caption := 'Ukryj haslo';
   Draw;
  end;
 with Bevel1 do
  begin
   X := 4;
   Y := 39;
   Width := 72;
   Height := 9;
   Color := 4;
   Caption := 'Akcja:';
   Draw;
  end;
 with OptionsBev do
  begin
   X := 4;
   Y := 6;
   Width := 20;
   Height := 5;
   Color := 1;
   Caption := 'Opcje:';
   Draw;
  end;
 with BtnBev do
  begin
   X := 4;
   Y := 14;
   Width := 20;
   Height := 7;
   Color := 1;
   Caption := 'Przyciski:';
   Draw;
  end;
 with ProgBev do
  begin
   X := 7;
   Y := 44;
   Width := 66;
   Height := 2;
   Color := 9;
   Caption := '';
   Draw;
  end;
 with FilesBev do
  begin
   X := 4;
   Y := 24;
   Width := 72;
   Height := 12;
   Color := 14;
   Caption := 'Pliki:';
   Draw;
  end;
 with InfoBev do
  begin
   X := 28;
   Y := 6;
   Width := 26;
   Height := 15;
   Color := 9;
   Caption := 'Info:';
   Draw;
  end;
 with PasBev do
  begin
   X := 58;
   Y := 11;
   Width := 18;
   Height := 10;
   Color := 5;
   Caption := 'Haslo:';
   Draw;
  end;
  with Label2 do
   begin
    X := 31;
    Y := 10;
    Color := 0;
    Caption := 'Nazwa: ';
    Draw;
   end;
  with Label3 do
   begin
    X := 31;
    Y := 12;
    Color := 0;
    Caption := 'Rozmiar: ';
    Draw;
   end;
  with Label4 do
   begin
    X := 31;
    Y := 14;
    Color := 0;
    Caption := 'Attr:';
    Draw;
   end;
  with Label5 do
   begin
    X := 31;
    Y := 16;
    Color := 0;
    Caption := 'Czas utw.: ';
    Draw;
   end;
  with Label6 do
   begin
    X := 31;
    Y := 18;
    Color := 0;
    Caption := 'Data utw.: ';
    Draw;
   end;
  with Label7 do
   begin
    X := 60;
    Y := 14;
    Color := 0;
    Caption := 'Podaj haslo:';
    Draw;
   end;
  with InF do
   begin
    X := 7;
    Y := 27;
    Color := 0;
    Caption := 'Sciezka do pliku do zakodowania:';
    Draw;
   end;
  with OuF do
   begin
    X := 7;
    Y := 31;
    Color := 0;
    Caption := 'Sciezka do pliku wynikowego:';
    Draw;
   end;
  with Input do
   begin
    X := 7;
    Y := 29;
    Width := 65;
    Color := 1;
    FontColor := 15;
    Text := 'C:\Autoexec.bat';
    Draw;
   end;
  with Output do
   begin
    X := 7;
    Y := 33;
    Width := 65;
    Color := 1;
    FontColor := 15;
    Text := 'C:\testcod.txt';
    Draw;
   end;
 with Button1 do
  begin
   X := 8;
   Y := 17;
   Width := 12;
   Height := 2;
   Color := 0;
   Caption := 'Start';
   Draw;
  end;
 with HelpBtn do
  begin
   X := 58;
   Y := 4;
   Width := 6;
   Height := 2;
   Color := 15;
   Caption := 'Help ';
   Draw;
  end;
 with AboutBtn do
  begin
   X := 65;
   Y := 4;
   Width := 6;
   Height := 2;
   Color := 15;
   Caption := 'About';
   Draw;
  end;
 with CloseBtn do
  begin
   X := 72;
   Y := 4;
   TextBackGround(1);
   Width := 6;
   Height := 2;
   Color := 15;
   Caption := 'Close';
   Draw;
   TextBackGround(BkCol);
  end;
 with ProgressBar1 do
  begin
   Width := 56;
   Height := 1;
   Max := 100;
   Ch := #219;
   BkCh := #177;
   Position := 0;
   X := 9;
   Y := 45;
   Color := 1;
   BkColor := 14;
   ShowText := True;
   TX := Width + X + 2;
   TY := Y;
   PerColor := 15;
   Draw;
  end;
  with Password do
   begin
    X := 60;
    Y := 16;
    Width := 14;
    Color := 1;
    Masked := True;
    Focused := False;
    MaskChar := '*';
    FontColor := 15;
    Text := '';
    Draw;
   end;
end;

procedure CursorOff;
 var
  R: Registers;
begin
 R.AH := $01;
 R.CH := $20;
 Intr($10, R);
end;

procedure CursorOn;
 var
  R: Registers;
begin
 R.AH := $01;
 R.CH := $06;
 Intr($10, R);
{ TextMode(Mode);}
end;

procedure CloseApp;
const
 Ln1 = 'xCoder 0.1 - copyright (c) 1999-2001 by _TeStON_ ';
 Ln2 = 'www:  http://www.teston.hg.pl/ ';
 Ln3 = 'e-mail:  testonek@wp.pl ';
 Ln4 = 'use:';
 Ln5 =  'xcoder.exe [(-/+)c] <input_file> <output_file> <password>';
 Ln6 =  'Switches:';
 Ln7 =  '  +c   - code  ';
 Ln8 =  '  -c   - decode';
begin
 CursorOn;
 TextMode(C80);
 ClrScr;
 GoToXY(40 - (Length(Ln1) div 2), 1); TextColor(15); Write(Ln1);
 GoToXY(40 - (Length(Ln2) div 2), 2); TextColor(13); Write(Ln2);
 GoToXY(40 - (Length(Ln3) div 2), 3); TextColor(11); Write(Ln3);
 GoToXY(40 - (Length(Ln4) div 2), 5); TextColor(9); Write(Ln4);
 GoToXY(40 - (Length(Ln5) div 2), 6); TextColor(10); Write(Ln5);
 GoToXY(40 - (Length(Ln6) div 2), 7); TextColor(12); Write(Ln6);
 GoToXY(40 - (Length(Ln7) div 2), 8); TextColor(11); Write(Ln7);
 GoToXY(40 - (Length(Ln8) div 2), 9); TextColor(11); Write(Ln8);
 Halt;
end;

procedure TLabel.Draw;
 var
  I: Integer;
begin
 GoToXY(X, Y);
 TextColor(BkCol); {!}
 if Width <> 0 then
  begin
   for I := X to X+Width do
    begin
     GoToXY(I, Y);
     Write(#219);
    end;
   if Length(Caption) > Width then
    Caption := Copy(Caption, 0, Width);
  end;
 GoToXY(X, Y);
 TextColor(Color);
 Write(Caption);
end;

procedure TBevel.Draw;
 var
  I, K, L: Integer;
begin
 TextColor(Color);
 GoToXY(X, Y);
 Write(#201);
 for I := X+1 to X+Width-1 do
  begin
   GoToXY(I, Y);
   Write(#205);
  end;
 GoToXY(X+Width, Y);
 Write(#187);

 for I := Y+1 to Y+Height-1 do
  begin
   GoToXY(X, I);
   Write(#186);
   GoToXY(X+Width, I);
   Write(#186);
  end;

 GoToXY(X, Y+Height);
 Write(#200);
 for I := X+1 to X+Width-1 do
  begin
   GoToXY(I, Y+Height);
   Write(#205);
  end;
 GoToXY(X+Width, Y+Height);
 Write(#188);

 if Caption <> '' then
  begin
   GoToXY(X+2, Y);
   Write(#185);
   TextColor(0);
   GoToXY(X+3, Y);
   Write(' '+Caption+' ');
   TextColor(Color);
   GoToXY(X+5+Length(Caption), Y);
   Write(#204);
   GoToXY(X+2, Y-1);
   Write(#201);
   GoToXY(X+5+Length(Caption), Y-1);
   Write(#187);
   for I := X+3 to X+5+Length(Caption)-1 do
    begin
     GoToXY(I, Y-1);
     Write(#205);
    end;
   GoToXY(X+2, Y+1);
   Write(#200);
   for I := X+3 to X+5+Length(Caption)-1 do
    begin
     GoToXY(I, Y+1);
     Write(#205);
    end;
   GoToXY(X+5+Length(Caption), Y+1);
   Write(#188);
  end;
end;

procedure TButton.Draw;
 var
  Col, W, H, jX, jY: Integer;
  BV: TBevel;
  I, K, L: Integer;
begin
 Col := Color;
 W := Width;
 H := Height;
 TextBackground(BkCol);
 TextColor(Color);
 jX := X;
 jY := Y;
 GoToXY(jX, jY);
 Write(#201);
 for I := jX+1 to jX+Width-1 do
  begin
   GoToXY(I, jY);
   Write(#205);
  end;
 GoToXY(jX+Width, jY);
 Write(#187);
 for I := jY+1 to jY+Height-1 do
  begin
   GoToXY(jX, I);
   Write(#186);
   GoToXY(jX+Width, I);
   Write(#186);
  end;
 GoToXY(jX, jY+Height);
 Write(#200);
 for I := jX+1 to jX+Width-1 do
  begin
   GoToXY(I, jY+Height);
   Write(#205);
  end;
 GoToXY(jX+Width, jY+Height);
 Write(#188);
 GoToXY(jX+(width div 2) - (Length(Caption) div 2), jY+1);
 TextColor(Red);
 TextBackground(BkCol);
 Write(Caption[1]);
 TextColor(Color);
 Write(Copy(Caption, 2, Length(Caption)-1));
end;

procedure TCloseButton.Draw;
 var
  Col, W, H, jX, jY: Integer;
  BV: TBevel;
  I, K, L: Integer;
begin
 Col := Color;
 W := Width;
 H := Height;
 TextBackground(1);
 TextColor(Color);
 jX := X;
 jY := Y;
 GoToXY(jX, jY);
 Write(#201);
 for I := jX+1 to jX+Width-1 do
  begin
   GoToXY(I, jY);
   Write(#205);
  end;
 GoToXY(jX+Width, jY);
 Write(#187);
 for I := jY+1 to jY+Height-1 do
  begin
   GoToXY(jX, I);
   Write(#186);
   GoToXY(jX+Width, I);
   Write(#186);
  end;
 GoToXY(jX, jY+Height);
 Write(#200);
 for I := jX+1 to jX+Width-1 do
  begin
   GoToXY(I, jY+Height);
   Write(#205);
  end;
 GoToXY(jX+Width, jY+Height);
 Write(#188);
 GoToXY(jX+(width div 2) - (Length(Caption) div 2), jY+1);
 TextColor(10);
 Write(Caption[1]);
 TextColor(Color);
 Write(Copy(Caption, 2, Length(Caption)-1));
end;

procedure TWindow.Draw;
 var
  Col, W, H, jX, jY: Integer;
  I, K, L: Integer;
begin
 Col := Color;
 W := Width;
 H := Height;
 TextColor(Color);
 jX := X;
 jY := Y;
 TextBackGround(1);
 GoToXY(jX, jY);
 Write(#201);
 for I := jX+1 to jX+Width-1 do
  begin
   GoToXY(I, jY);
   Write(#205);
  end;
 GoToXY(jX+Width, jY);
 Write(#187);
 for I := jY+1 to jY+Height-1 do
  begin
   if I <> jY+2 then
    begin
     GoToXY(jX, I);
     Write(#186);
     GoToXY(jX+Width, I);
     Write(#186);
    end else
    begin
     TextBackGround(1);
     GoToXY(jX, I);
     Write(#204);
     GoToXY(jX+Width, I);
     Write(#185);
{     TextBackGround(BkCol);}
    end;
  end;
 GoToXY(jX, jY+Height);
 Write(#200);
 for I := jX+1 to jX+Width-1 do
  begin
{   TextBackGround(BkCol);}
   GoToXY(I, jY+Height);
   Write(#205);
   TextBackGround(1);
   GoToXY(I, jY+2);
   Write(#205);
  end;
 GoToXY(jX+Width, jY+Height);
 Write(#188);
 GoToXY(jX+1, jY+1);
 TextColor(Color);
 Write(' '+Caption+'         ');
end;

procedure TCheckBox.Draw;
begin
 GoToXY(X, Y);
 TextColor(0);
 TextBackground(Color);
 if Checked then
  Write(CharCheck) else
  Write(' ');
 GoToXY(X+2, Y);
 TextColor(Red);
 TextBackground(BkCol);
 Write(Caption[1]);
 TextColor(FontColor);
 Write(Copy(Caption, 2, Length(Caption)-1));
end;


procedure TEdit.Draw;
 var
  I, K, L: LongInt;
  Znak: Char;
  ShowCarret: Boolean;
begin
 for I := X to X+Width do
  begin
   GoToXY(I, Y);
   TextColor(Color);
   Write(#219);
  end;
 TextBackground(color);
 GoToXY(X, Y);
 TextColor(FontColor);
 Write(Text);
 TextBackground(BkCol);
 if Focused then
  begin
   L := 1;
   ShowCarret := False;
   repeat
    Dec(L);
    if L <= 5000 then
     begin
      ShowCarret := True;
     end else
    if L >= 5000 then
     begin
      ShowCarret := False;
     end;
    if L <=0 then
     L := 10000;
     if ShowCarret then
      begin
       TextBackground(color);
       GoToXY(X+Length(Text), Y);
       TextColor(FontColor);
       Write(#221);
      end else
      begin
       TextBackground(color);
       GoToXY(X+Length(Text), Y);
       TextColor(FontColor);
       Write(' ');
      end;
    if KeyPressed then
     begin
      Znak := ReadKey;
      if Znak = #0 then
       Znak := ReadKey;
      if Znak = #9 then
       begin
        GoToXY(X+Length(Text), Y);
        TextColor(FontColor);
        Write(' ');
        TabHit;
        Exit;
       end else
      if Ord(Znak) in [32..122] then
       Text := Text + Znak else
       if Znak = #8 then
        if Text <> '' then
         Text := Copy(Text, 0, Length(Text)-1);
      if Length(Text) > Width then
       Text := Copy(Text, 0, Width);
      for I := X to X+Width do
       begin
        GoToXY(I, Y);
        TextColor(Color);
        Write(#219);
      end;
      TextBackground(color);
      GoToXY(X, Y);
      TextColor(FontColor);
      Write(Text);
      if ShowCarret then
       begin
        GoToXY(X+Length(Text), Y);
        TextColor(FontColor);
        Write(#221);
       end else
       begin
        GoToXY(X+Length(Text), Y);
        TextColor(FontColor);
        Write(' ');
       end;
      TextBackground(BkCol);
     end;
   until (Znak = #13)or(Znak = #27)or(TMouseClikIn(0, 0, 78, 49,1));
  end;
 CursorOff;
 Focused := False;
 for I := X to X+Width do
  begin
   GoToXY(I, Y);
   TextColor(Color);
   Write(#219);
 end;
 TextBackground(Color);
 GoToXY(X, Y);
 TextColor(FontColor);
 Write(Text);
 TextBackground(BkCol);
end;

procedure TMaskEdit.Draw;
 var
  I, K, L: LongInt;
  Znak: Char;
  ShowCarret: Boolean;
begin
 for I := X to X+Width do
  begin
   GoToXY(I, Y);
   TextColor(Color);
   Write(#219);
  end;
 TextBackground(color);
 GoToXY(X, Y);
 TextColor(FontColor);
 if not Masked then
  Write(Text) else
  for I := 1 to Length(Text) do
   Write(MaskChar);
 TextBackground(BkCol);
 if Focused then
  begin
   L := 1;
   ShowCarret := False;
   repeat
    Dec(L);
    if L <= 5000 then
     begin
      ShowCarret := True;
     end else
    if L >= 5000 then
     begin
      ShowCarret := False;
     end;
    if L <=0 then
     L := 10000;
     if ShowCarret then
      begin
       TextBackground(color);
       GoToXY(X+Length(Text), Y);
       TextColor(FontColor);
       Write(#221);
      end else
      begin
       TextBackground(color);
       GoToXY(X+Length(Text), Y);
       TextColor(FontColor);
       Write(' ');
      end;
    if KeyPressed then
     begin
      Znak := ReadKey;
      if Znak = #0 then
       Znak := ReadKey;
      if Znak = #9 then
       begin
        GoToXY(X+Length(Text), Y);
        TextColor(FontColor);
        Write(' ');
        TabHit;
        Exit;
       end else
      if Ord(Znak) in [32..122] then
       Text := Text + Znak else
       if Znak = #8 then
        if Text <> '' then
         Text := Copy(Text, 0, Length(Text)-1);
      if Length(Text) > Width then
       Text := Copy(Text, 0, Width);
      for I := X to X+Width do
       begin
        GoToXY(I, Y);
        TextColor(Color);
        Write(#219);
      end;
      TextBackground(color);
      GoToXY(X, Y);
      TextColor(FontColor);
      if not Masked then
       Write(Text) else
       for I := 1 to Length(Text) do
        Write(MaskChar);
      if ShowCarret then
       begin
        GoToXY(X+Length(Text), Y);
        TextColor(FontColor);
        Write(#221);
       end else
       begin
        GoToXY(X+Length(Text), Y);
        TextColor(FontColor);
        Write(' ');
       end;
      TextBackground(BkCol);
     end;
   until (Znak = #13)or(Znak = #27)or(TMouseClikIn(0, 0, 78, 49,1));
  end;
 CursorOff;
 Focused := False;
 for I := X to X+Width do
  begin
   GoToXY(I, Y);
   TextColor(Color);
   Write(#219);
 end;
 TextBackground(Color);
 GoToXY(X, Y);
 TextColor(FontColor);
 if not Masked then
  Write(Text) else
  for I := 1 to Length(Text) do
   Write(MaskChar);
 TextBackground(BkCol);
end;



function IntToStr(I: Integer): String;
 var
  S: String;
begin
 Str(I, S);
 IntToStr := S;
end;

function ExtractFileName(S: String): String;
 var
  Result, P: String;
  I: Integer;
begin
 Result := '';
 P := '';
 I := Length(S);
 if I > 0 then
  begin
   repeat
    P := P + S[I];
    Dec(I);
   until (S[I] = '\')or(I=0);
   for I := Length(P) downto 1 do
    Result := Result + P[I];
  end;
 ExtractFileName := Result;
end;

procedure TProgressBar.Draw;
 var
  I, K, Per: Integer;
begin
 if (Max <> 0)and(Position <> 0) then
  begin
   Zap := Round(Width/(Max/Position));
  end else
   Zap := -1;
 if Zap <> ZapS then
  begin
   TextBackground(BkCol);
   {Background}
   for K := 1 to Height do
    for I := X to X+Width do
     begin
      GoToXY(I, Y+K-1);
      TextColor(BkColor);
      Write(BkCh);
     end;
   if Max < Position then Zap := Width;
   {Foreground}
   for K := 1 to Height do
    for I := X to X+Zap do
     begin
      GoToXY(I, Y+K-1);
      TextColor(Color);
      Write(Ch);
     end;
  if ShowText then
   begin
    Per := Round((Position/Max)*100);
    if Per > 100 then
     Per := 100;
    GoToXY(TX, TY);
    TextColor(PerColor);
    Write('      ');
    GoToXY(TX, TY);
    Write(IntToStr(Per)+' %');
   end;
   ZapS := Zap;
  end;
 if Per = 99 then
  if ShowText then
   begin
    Per := Round((Position/Max)*100);
    if Per > 100 then
     Per := 100;
    GoToXY(TX, TY);
    TextColor(PerColor);
    Write('      ');
    GoToXY(TX, TY);
    Write('100 %');
   end;
end;

procedure THelpBox.Draw;
 var
  Col, W, H, jX, jY: Integer;
  I, K, L: Integer;
  OK: Boolean;
  Btn: TButton;
begin
 Col := Color;
 W := Width;
 H := Height;
 TextColor(Color);
 jX := X;
 jY := Y;
 TextBackGround(1);
 GoToXY(jX, jY);
 Write(#201);
 for I := jX+1 to jX+Width-1 do
  begin
   GoToXY(I, jY);
   Write(#205);
  end;
 GoToXY(jX+Width, jY);
 Write(#187);
 for I := jY+1 to jY+Height-1 do
  begin
   if I <> jY+2 then
    begin
     GoToXY(jX, I);
     Write(#186);
     GoToXY(jX+Width, I);
     Write(#186);
    end else
    begin
     TextBackGround(1);
     GoToXY(jX, I);
     Write(#204);
     GoToXY(jX+Width, I);
     Write(#185);
{     TextBackGround(BkCol);}
    end;
  end;
 GoToXY(jX, jY+Height);
 Write(#200);
 for I := jX+1 to jX+Width-1 do
  begin
{   TextBackGround(BkCol);}
   GoToXY(I, jY+Height);
   Write(#205);
   TextBackGround(1);
   GoToXY(I, jY+2);
   Write(#205);
  end;
 TextColor(BkColor);
 for I := jX+1 to jX+Width-1 do
  for K := jY+3 to jY+Height-1 do
   begin
    GoToXY(I, K);
    Write(#219);
   end;
 TextColor(1);
 for I := jX+1 to jX+Width-1 do
  begin
   GoToXY(I, jY+1);
   Write(#219);
  end;
 TextColor(Color);
 GoToXY(jX+Width, jY+Height);
 Write(#188);
 GoToXY(jX+1, jY+1);
 with Btn do
  begin
   Width := 14;
   Height := 2;
   X := jX + (W div 2) - (Width div 2);
   Y := jY + H - Height - 2;
   Caption := 'OK';
   Color := 0;
   Draw;
  end;
 TextBackground(1);
 TextColor(Color);
 GoToXY(jX+1, jY+1); Write(' Help');
 TextColor(0);
 TextBackground(BkColor);
 GoToXY(jX+3, jY+4);  Write('Gorace ;) klawisze:');
 GoToXY(jX+3, jY+6);  Write('Alt  + K  - Koduj / Dekoduj');
 GoToXY(jX+3, jY+7);  Write('Alt  + U  - Ukryj haslo');
 GoToXY(jX+3, jY+8);  Write('Alt  + S  - Start');
 GoToXY(jX+3, jY+9);  Write('Ctrl + C - Zamknij (Close)');
 GoToXY(jX+3, jY+10); Write('Ctrl + A - O Programie (About)');
 GoToXY(jX+3, jY+11); Write('Ctrl + H - Pomoc (Help) ;)');
 GoToXY(jX+3, jY+12); Write('Tab      - Przejscie');
 GoToXY(jX+3, jY+14); Write('Alt  + O  - Aby stad wyjsc ;)');
 GoToXY(jX+3, jY+15); Write('ENTER    - j/w');
 ShowMouse;
 OK := False;
 repeat
  ShowMouse;
  if TMouseIn(Btn.X, Btn.Y, Btn.X + Btn.Width, Btn.Y + Btn.Height) then
   begin
    Btn.Color := 15;
    Btn.Draw;
   end else
  if not TMouseIn(Btn.X, Btn.Y, Btn.X + Btn.Width, Btn.Y + Btn.Height) then
   begin
    Btn.Color := 0;
    Btn.Draw;
   end;
  if TMouseClikIn(Btn.X, Btn.Y, Btn.X + Btn.Width, Btn.Y + Btn.Height, 1) then
   OK := True;
  if KeyPressed then
   Zk := ReadKey;
  if (Zk = #24)or(Zk=#13) then
   OK := True;
 until OK;
 ClrScr;
 DrawAll;
 ShowMouse;
 Delay(300);
end;

procedure TAboutBox.Draw;
 var
  Col, W, H, jX, jY: Integer;
  I, K, L: Integer;
  OK: Boolean;
  Btn: TButton;
 const
  Ln1 = 'xCoder 0.1 ';
  Ln2 = 'Copyright (c) 1999-2001 by';
  Ln3 = '_TeStON_ (17 lat)';
  Ln4 = '21.07.2001 ';
  Ln5 = 'http://www.teston.hg.pl/ ';
  Ln6 = 'testonek@wp.pl ';
begin
 Col := Color;
 W := Width;
 H := Height;
 TextColor(Color);
 jX := X;
 jY := Y;
 TextBackGround(1);
 GoToXY(jX, jY);
 Write(#201);
 for I := jX+1 to jX+Width-1 do
  begin
   GoToXY(I, jY);
   Write(#205);
  end;
 GoToXY(jX+Width, jY);
 Write(#187);
 for I := jY+1 to jY+Height-1 do
  begin
   if I <> jY+2 then
    begin
     GoToXY(jX, I);
     Write(#186);
     GoToXY(jX+Width, I);
     Write(#186);
    end else
    begin
     TextBackGround(1);
     GoToXY(jX, I);
     Write(#204);
     GoToXY(jX+Width, I);
     Write(#185);
    end;
  end;
 GoToXY(jX, jY+Height);
 Write(#200);
 for I := jX+1 to jX+Width-1 do
  begin
   GoToXY(I, jY+Height);
   Write(#205);
   TextBackGround(1);
   GoToXY(I, jY+2);
   Write(#205);
  end;
 TextColor(BkColor);
 for I := jX+1 to jX+Width-1 do
  for K := jY+3 to jY+Height-1 do
   begin
    GoToXY(I, K);
    Write(#219);
   end;
 TextColor(1);
 for I := jX+1 to jX+Width-1 do
  begin
   GoToXY(I, jY+1);
   Write(#219);
  end;
 TextColor(Color);
 GoToXY(jX+Width, jY+Height);
 Write(#188);
 GoToXY(jX+1, jY+1);
 with Btn do
  begin
   Width := 14;
   Height := 2;
   X := jX + (W div 2) - (Width div 2);
   Y := jY + H - Height - 2;
   Caption := 'OK';
   Color := 0;
   Draw;
  end;
 TextBackground(1);
 TextColor(Color);
 GoToXY(jX+1, jY+1); Write(' About this program...');
 TextColor(0);
 TextBackground(BkColor);
 GoToXY(jX+(W div 2) - (Length(Ln1) div 2), jY+4); TextColor(1); Write(Ln1);
 GoToXY(jX+(W div 2) - (Length(Ln2) div 2), jY+6); TextColor(5); Write(Ln2);
 GoToXY(jX+(W div 2) - (Length(Ln3) div 2), jY+8); TextColor(0); Write(Ln3);
 GoToXY(jX+(W div 2) - (Length(Ln4) div 2), jY+10); TextColor(9); Write(Ln4);
 GoToXY(jX+(W div 2) - (Length(Ln5) div 2), jY+12); TextColor(0); Write(Ln5);
 GoToXY(jX+(W div 2) - (Length(Ln6) div 2), jY+14); TextColor(0); Write(Ln6);
 ShowMouse;
 OK := False;
 repeat
  ShowMouse;
  if TMouseIn(Btn.X, Btn.Y, Btn.X + Btn.Width, Btn.Y + Btn.Height) then
   begin
    Btn.Color := 15;
    Btn.Draw;
   end else
  if not TMouseIn(Btn.X, Btn.Y, Btn.X + Btn.Width, Btn.Y + Btn.Height) then
   begin
    Btn.Color := 0;
    Btn.Draw;
   end;
  if TMouseClikIn(Btn.X, Btn.Y, Btn.X + Btn.Width, Btn.Y + Btn.Height, 1) then
   OK := True;
  if KeyPressed then
   Zk := ReadKey;
  if (Zk = #24)or(Zk=#13) then
   OK := True;
 until OK;
 ClrScr;
 DrawAll;
 ShowMouse;
 Delay(300);
end;

procedure Start;
begin
 Assign(BF, Input.Text);
 {$I-}
 Reset(BF);
 {$I+}
 if IOResult <> 0 then
  begin
   with Label1 do
    begin
     X := 7;
     Y := 42;
     Width := 40;
     Color := 0 + 128;
     Caption := '"CAN`T READ FROM INPUT FILE"';
     Draw;
    end;
{   Input.Text := '"CAN`T READ FROM THIS FILE"';
   Input.Draw;}
   Exit;
  end;
 Size := 0;
 Size := FileSize(BF);
 with Label2 do
  begin
   X := 31;
   Y := 10;
   Color := 0;
   Width := 22;
   Caption := 'Nazwa: '+ExtractFileName(Input.Text);
   Draw;
  end;
 with Label3 do
  begin
   X := 31;
   Y := 12;
   Color := 0;
   Width := 22;
   Caption := 'Rozmiar: '+IntToStr(Size div 1024)+','+IntToStr(Size mod 1024)+' kB';
   Draw;
  end;
 with Label4 do
  begin
   X := 31;
   Y := 14;
   Color := 0;
   Width := 22;
   ATTRS := '';
   GetFAttr(BF, Attr);
   if Attr and ReadOnly <> 0 then
    ATTRS := ATTRS + ' R';
   if Attr and Hidden <> 0 then
    ATTRS := ATTRS + ' H';
   if Attr and SysFile <> 0 then
    ATTRS := ATTRS + ' S';
   if Attr and VolumeID <> 0 then
    ATTRS := ATTRS + ' V';
   if Attr and Directory <> 0 then
    ATTRS := ATTRS + ' D';
   if Attr and Archive <> 0 then
    ATTRS := ATTRS + ' A';
   if ATTRS = '' then
    ATTRS := ' N';
   Caption := 'Attr:' + ATTRS;
   Draw;
  end;
 with Label5 do
  begin
   X := 31;
   Y := 16;
   Color := 0;
   Width := 22;
   GetFTime(BF, Time);
   UnpackTime(Time,DT);
   with DT do
    Caption := 'Czas utw.: '+PZero(Hour)+':'+PZero(Min)+':'+PZero(Sec);
   Draw;
  end;
 with Label6 do
  begin
   X := 31;
   Y := 18;
   Color := 0;
   Width := 22;
   GetFTime(BF, Time);
   UnpackTime(Time,DT);
   with DT do
    Caption := 'Data utw.: '+PZero(Day)+'-'+PZero(Month)+'-'+PZero(Year);
   Draw;
  end;
 Close(BF);
 if Size > 0 then
  begin
   with Label1 do
    begin
     X := 7;
     Y := 42;
    Width := 40;
     Color := 0 + 128;
     if CheckBox1.Checked then
      Caption := MT_CODING else
      Caption := MT_DECODING;
     Draw;
    end;
   ProgressBar1.Max := Size;
   ProgressBar1.Position := 0;
   ProgressBar1.Draw;
   Assign(BF, Input.Text);
   Reset(BF);
   Read(BF, w1);
   Read(BF, w2);
   Read(BF, w3);
   if CheckBox1.Checked then
    begin
     if (w1 = Ord('T'))and(w2 = Ord('C'))and(w3 = Ord('F')) then
      begin
       with Label1 do
        begin
         X := 7;
         Y := 42;
         Width := 40;
         Color := 0 + 128;
         Caption := '"INPUT FILE IS ALREADY CODED"';
         Draw;
        end;
{       Input.Text := '"FILE IS ALREADY CODED"';
       input.Draw;}
       Close(BF);
       Exit;
      end;
    end else
    begin
     if (w1 <> Ord('T'))or(w2 <> Ord('C'))or(w3 <> Ord('F')) then
      begin
       with Label1 do
        begin
         X := 7;
         Y := 42;
         Width := 40;
         Color := 0 + 128;
         Caption := '"INPUT FILE ISN`T CODED"';
         Draw;
        end;
{       Input.Text := '"FILE ISN`T CODED"';
       input.Draw;}
       Close(BF);
       Exit;
      end;
    end;
   Close(BF);
   Assign(BFD, Output.Text);
   {$I-}
   Rewrite(BFD);
   {$I+}
   if IOResult <> 0 then
    begin
     Output.Text := '"CAN`T WRITE TO FILE"';
     Output.Draw;
     Exit;
    end;
   Assign(BF, Input.Text);
   Reset(BF);
   X := 0;
   Y := 0;
   if Password.Text <> '' then
    Klucz := MakeKey(Password.Text) else
    begin
     Label1.Caption := 'Nie wpisano hasla.';
     Label1.Color := 0 + 128;
     Label1.Draw;
     Close(BFD);
     Close(BF);
     Exit;
    end;
   repeat
    Inc(X);
    if CheckBox1.Checked then
     begin
      if X = 1 then
       begin
        Prze := Ord('T');
        Write(BFD, Prze);
        Prze := Ord('C');
        Write(BFD, Prze);
        Prze := Ord('F');
        Write(BFD, Prze);
       end else
       begin
        Read(BF, Wart);
        Prze := (Wart xor Klucz) xor (Klucz div 4);
        Write(BFD, Prze);
        Inc(ProgressBar1.Position);
        ProgressBar1.Draw;
       end;
     end else
     begin
      Inc(Y);
      if Y > 3 then
       begin
        Read(BF, Wart);
        Prze := (Wart xor Klucz) xor (Klucz div 4);
        Write(BFD, Prze);
        Inc(ProgressBar1.Position);
        ProgressBar1.Draw;
       end else
       begin
        Read(BF, Wart);
        Inc(ProgressBar1.Position);
       end;
     end;
    if TMouseIn(CloseBtn.X, CloseBtn.Y, CloseBtn.X + CloseBtn.Width+1, CloseBtn.Y + CloseBtn.Height+1) then
     begin
      CloseBtn.Color := 12;
      CloseBtn.Draw;
     end else
    if not TMouseIn(CloseBtn.X, CloseBtn.Y, CloseBtn.X + CloseBtn.Width+1, CloseBtn.Y + CloseBtn.Height+1) then
     begin
      CloseBtn.Color := 15;
      CloseBtn.Draw;
     end;
    if TMouseClikIn(CloseBtn.X, CloseBtn.Y, CloseBtn.X + CloseBtn.Width+1, CloseBtn.Y + CloseBtn.Height+1, 1) then
     CloseApp;
    if KeyPressed then
     Zk2 := ReadKey;
    TextBackground(BkCol);
   until (Eof(BF))or(Zk2=#27);
{   CheckBox1.Checked := not CheckBox1.Checked;}
   with Label1 do
    begin
     X := 7;
     Y := 42;
     Width := 40;
     Color := 0 + 128;
     if Zk2 <> #27 then
      Caption := MT_DONE else
      begin
       Caption := MT_ABORT;
       ProgressBar1.Position := 0;
       ProgressBar1.Draw;
       Erase(BFD);
      end;
     Draw;
    end;
   Close(BF);
   Close(BFD);
   if ParamCount = 4 then
    CloseApp;
  end;
end;

procedure CheckBox1Click;
begin
 CheckBox1.Checked := not CheckBox1.Checked;
 HideMouse;
 CheckBox1.Draw;
 ShowMouse;
 Delay(300);
end;

procedure MaskClick;
begin
 Mask.Checked := not Mask.Checked;
 Password.Masked := Mask.Checked;
 HideMouse;
 Mask.Draw;
 Password.Draw;
 ShowMouse;
 Delay(300);
end;

procedure HelpClick;
begin
 HelpBtn.Color := 15;
 HelpBtn.Draw;
 with HelpBox do
  begin
   Width := 34;
   Height := 26;
   X := 39 - (Width div 2);
   Y := 24 - (Height div 2);
   Color := 14;
   BkColor := 7;
   Draw;
  end;
end;

procedure AboutClick;
begin
 AboutBtn.Color := 15;
 AboutBtn.Draw;
 with AboutBox do
  begin
   Width := 40;
   Height := 22;
   X := 39 - (Width div 2);
   Y := 24 - (Height div 2);
   Color := 14;
   BkColor := 7;
   Draw;
  end;
end;

begin
 if (not MouseExist)and(ParamCount <> 4) then
  begin
   CursorOn;
   TextMode(C80);
   ClrScr;
   Write('Error: Can''t load Mouse Driver !!!');
   Halt;
  end;
 Init;
 CursorOff;
 ShowMouse;
 if ParamCount = 4 then
  begin
   if (ParamStr(1) = '+c')or(ParamStr(1) = '+C') then
    CheckBox1.Checked := True else
   if (ParamStr(1) = '-c')or(ParamStr(1) = '-C') then
    CheckBox1.Checked := False else
    CheckBox1.Checked := True;
   CheckBox1.Draw;
   Input.Text := ParamStr(2);
   Input.Draw;
   Output.Text := ParamStr(3);
   Output.Draw;
   Password.Text := ParamStr(4);
   Password.Draw;
   Start;
  end else
  if ParamCount > 0 then
   begin
    CloseApp;
   end;
 repeat
  ShowMouse;
   begin
    if TMouseIn(CheckBox1.X, CheckBox1.Y, CheckBox1.X + Length(CheckBox1.Caption), CheckBox1.Y) then
     begin
      CheckBox1.FontColor := 15;
      CheckBox1.Draw;
     end else
    if not TMouseIn(CheckBox1.X, CheckBox1.Y, CheckBox1.X + Length(CheckBox1.Caption)+4, CheckBox1.Y) then
     begin
      CheckBox1.FontColor := 0;
      CheckBox1.Draw;
     end;
    if TMouseIn(Mask.X, Mask.Y, Mask.X + Length(Mask.Caption), Mask.Y) then
     begin
      Mask.FontColor := 15;
      Mask.Draw;
     end else
    if not TMouseIn(Mask.X, Mask.Y, Mask.X + Length(Mask.Caption), Mask.Y) then
     begin
      Mask.FontColor := 0;
      Mask.Draw;
     end;
    if TMouseIn(CloseBtn.X, CloseBtn.Y, CloseBtn.X + CloseBtn.Width, CloseBtn.Y + CloseBtn.Height) then
     begin
      CloseBtn.Color := 12;
      CloseBtn.Draw;
     end else
    if not TMouseIn(CloseBtn.X, CloseBtn.Y, CloseBtn.X + CloseBtn.Width, CloseBtn.Y + CloseBtn.Height) then
     begin
      CloseBtn.Color := 15;
      CloseBtn.Draw;
     end;
    if TMouseIn(HelpBtn.X, HelpBtn.Y, HelpBtn.X + HelpBtn.Width, HelpBtn.Y + HelpBtn.Height) then
     begin
      HelpBtn.Color := 12;
      HelpBtn.Draw;
     end else
    if not TMouseIn(HelpBtn.X, HelpBtn.Y, HelpBtn.X + HelpBtn.Width, HelpBtn.Y + HelpBtn.Height) then
     begin
      HelpBtn.Color := 15;
      HelpBtn.Draw;
     end;
    if TMouseIn(AboutBtn.X, AboutBtn.Y, AboutBtn.X + AboutBtn.Width, AboutBtn.Y + AboutBtn.Height) then
     begin
      AboutBtn.Color := 12;
      AboutBtn.Draw;
     end else
    if not TMouseIn(AboutBtn.X, AboutBtn.Y, AboutBtn.X + AboutBtn.Width, AboutBtn.Y + AboutBtn.Height) then
     begin
      AboutBtn.Color := 15;
      AboutBtn.Draw;
     end;
    if TMouseIn(Button1.X, Button1.Y, Button1.X + Button1.Width, Button1.Y + Button1.Height) then
     begin
      Button1.Color := 15;
      Button1.Draw;
     end else
    if not TMouseIn(Button1.X, Button1.Y, Button1.X + Button1.Width, Button1.Y + Button1.Height) then
     begin
      Button1.Color := 0;
      Button1.Draw;
     end;
   end;
   if TMouseClikIn(CheckBox1.X, CheckBox1.Y, CheckBox1.X + Length(CheckBox1.Caption)+4, CheckBox1.Y, 1) then
    begin
     CheckBox1Click;
    end;
   if TMouseClikIn(Mask.X, Mask.Y, Mask.X + Length(Mask.Caption), Mask.Y, 1) then
    begin
     MaskClick;
    end;
   if TMouseClikIn(Password.X, Password.Y, Password.X + Password.Width, Password.Y+1, 1) then
    begin
     Delay(100);
     Password.Focused := True;
     HideMouse;
     Password.Draw;
     ShowMouse;
    end;
   if TMouseClikIn(Input.X, Input.Y, Input.X + Input.Width, Input.Y+1, 1) then
    begin
     Delay(100);
     Input.Focused := True;
     HideMouse;
     Input.Draw;
     ShowMouse;
    end;
   if TMouseClikIn(Output.X, Output.Y, Output.X + Output.Width, Output.Y+1, 1) then
    begin
     Delay(100);
     Output.Focused := True;
     HideMouse;
     Output.Draw;
     ShowMouse;
    end;
   if TMouseClikIn(Button1.X, Button1.Y, Button1.X + Button1.Width, Button1.Y + Button1.Height, 1) then
    begin
     Delay(100);
     ShowMouse;
     Button1.Color := 0;
     Button1.Draw;
     ShowMouse;
     Start;
     ShowMouse;
    end;
   if TMouseClikIn(HelpBtn.X, HelpBtn.Y, HelpBtn.X + HelpBtn.Width, HelpBtn.Y+ HelpBtn.Height, 1) then
    begin
     HelpClick;
    end;
   if TMouseClikIn(AboutBtn.X, AboutBtn.Y, AboutBtn.X + AboutBtn.Width, AboutBtn.Y+ AboutBtn.Height, 1) then
    begin
     AboutClick;
    end;
   if TMouseClikIn(CloseBtn.X, CloseBtn.Y, CloseBtn.X + CloseBtn.Width, CloseBtn.Y + CloseBtn.Height, 1) then
    CloseApp;
  if KeyPressed then
   Zk := ReadKey;
  if Zk = #37 then
   CheckBox1Click else
  if Zk = #8 then
   HelpClick else
  if Zk = #1 then
   AboutClick else
  if Zk = #22 then
   MaskClick else
  if Zk = #3 then
   CloseApp else
  if Zk = #9 then
   begin
    TabHit;
   end else
  if Zk = #31 then
   Start;
  if Zk <> #27 then
   Zk := #0;
 until (ATTRS='fdfsdf')or(Zk = #27);
 CloseApp;
end.
